google.load('gdata', '2.x', {packages: ['analytics']});
google.load('visualization', '1', {'packages':['table','barchart','columnchart','linechart','piechart']});

jQuery(function($){

google.setOnLoadCallback(function(){

  myService = new google.gdata.analytics.AnalyticsService('gaExportAPI_acctSample_v2.0');
  scope = 'https://www.google.com/analytics/feeds';

  $('#authButton').click(function() {
    if (!google.accounts.user.checkLogin(scope)) {
      google.accounts.user.login(scope);
    } else {
      google.accounts.user.logout();
      getStatus();
    }
  });
  getStatus();

});

//日付の設定
  var today = new Date();
  var year = today.getFullYear();
  var month = today.getMonth() + 1;
  if(month < 10) {
    month = '0' + month;
  }
  var date = today.getDate();
  if(date < 10){
    date = '0' + date;
  }
  var endDate = year + '-' + month + '-' + date;
  $('#endDate').val(endDate);
  
//datepicker
  $("#startDate,#endDate").datepicker({
    dateFormat: "yy-mm-dd",
    dayNames: ["日","月","火","水","木","金","土"],
    dayNamesMin: ["日","月","火","水","木","金","土"],
    dayNamesShort: ["日","月","火","水","木","金","土"],
    monthNames: ["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],
    monthNames: ["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],
    nextText: "→",
    prevText: "←"
  });

function getStatus() {
  $('#accountMax').keypress(getAccountFeed);
  $('#getAccount').click(getAccountFeed);
  $('#getData_m').click(getDataFeed_m);
  $('#getData_w').click(getDataFeed_w);
  $('#getData_d').click(getDataFeed_d);
  $('#getData_dow').click(getDataFeed_dow);
  $('#getData_2').click(getDataFeed_2);
  $('#getData_3').click(getDataFeed_3);
  $('#getData_4').click(getDataFeed_4);

  var dataControls = $('#dataControls').get(0);
  var loginButton = $('#authButton').get(0);
  if (!google.accounts.user.checkLogin(scope)) {
    $(dataControls).css('display', 'none');
    $(loginButton).html('Access Google Analytics');
  } else {
    $(dataControls).css('display', 'block');
    $(loginButton).html('Logout');
  }
}

/*
* アカウントのデータを表示する
*/
function getAccountFeed() {
  var myFeedUri = 'https://www.google.com/analytics/feeds/accounts/default?max-results=' + $('#accountMax').val();
  myService.getAccountFeed(myFeedUri, handleAccountFeed, handleError);
}

function handleAccountFeed(result) {
  var entries = result.feed.getEntries();

// テーブルチャートの設定
  var data = new google.visualization.DataTable();
  data.addColumn('string', 'Account ID');
  data.addColumn('string', 'Profile Name');
  data.addColumn('string', 'Table ID');
  data.addColumn('string', 'Timezone');
  data.addColumn('string', 'Currency');
  data.addColumn('string', 'Has Goals');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    data.addRow([
      entry.getPropertyValue('ga:AccountId'),
      entry.getTitle().getText(),
      entry.getTableId().getValue(),
      entry.getPropertyValue('ga:timezone'),
      entry.getPropertyValue('ga:currency'),
      entry.getGoals().length != 0 ? 'Yes' : ''
    ]);
  }
  
  var options = {
//    width: 740
  };
  var panel = $('#table_panel').get(0);
  var chart = new google.visualization.Table(panel);
  chart.draw(data, options);

}

/*
* プロファイルごとのデータを表示する レポート(1ヶ月単位)
*/
function getDataFeed_m() {
  var myFeedUri = 'https://www.google.com/analytics/feeds/data' +
    '?start-date=' + $('#startDate').val() +
    '&end-date=' + $('#endDate').val() +
    '&dimensions=ga:month' +
    '&metrics=ga:visits,ga:visitors,ga:pageviews,ga:pageviewsPerVisit' +
    '&sort=ga:month' +
    '&ids=' + $('#tableId').val();
  
  myService.getDataFeed(myFeedUri, handleDataFeed_m, handleError);
}

function handleDataFeed_m(result) {
  var entries = result.feed.getEntries();

// テーブルチャートの設定
  var data = new google.visualization.DataTable();
  data.addColumn('string', '月');
  data.addColumn('number', '訪問数');
  data.addColumn('number', 'ユーザー数');
  data.addColumn('number', 'ページビュー数');
  data.addColumn('number', '平均ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    data.addRow([
       entry.getValueOf('ga:month'),
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews'),
       entry.getValueOf('ga:pageviewsPerVisit')
    ]);
  }
  
  var formatter = new google.visualization.TableNumberFormat({
    fractionDigits: '2'
  });
  formatter.format(data,4);
  var formatter_date = new google.visualization.TablePatternFormat(
    '{0}月'
  );
  formatter_date.format(data,[0]);
  
  var options = {
//    width: 740
  };
  var panel = $('#table_panel_m').get(0);
  var chart_table = new google.visualization.Table(panel);
  chart_table.draw(data, options);

// ラインチャートの設定
  var linechart = new google.visualization.DataTable();
  linechart.addColumn('string', '日付');
  linechart.addColumn('number', '訪問数');
  linechart.addColumn('number', 'ユーザー数');
  linechart.addColumn('number', 'ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    linechart.addRow([
       entry.getValueOf('ga:month'),
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews')
    ]);
  }
  
  var options_line = {
//    width: 740,
    height: 210
  };
  var panel_linechart = $('#linechart_panel_m').get(0);
  var chart_line = new google.visualization.LineChart(panel_linechart);
  chart_line.draw(linechart, options_line);

// テーブルの並び替え時にチャートも並び替える
  google.visualization.events.addListener(chart_table, 'sort',
    function(event) {
      linechart.sort([{column: event.column, desc: !event.ascending}]);
      chart_line.draw(linechart, options_line);
    });
}

/*
* プロファイルごとのデータを表示する レポート(1週間単位)
*/
function getDataFeed_w() {
  var myFeedUri = 'https://www.google.com/analytics/feeds/data' +
    '?start-date=' + $('#startDate').val() +
    '&end-date=' + $('#endDate').val() +
    '&dimensions=ga:week' +
    '&metrics=ga:visits,ga:visitors,ga:pageviews,ga:pageviewsPerVisit' +
    '&sort=ga:week' +
    '&ids=' + $('#tableId').val();
  
  myService.getDataFeed(myFeedUri, handleDataFeed_w, handleError);
}

function handleDataFeed_w(result) {
  var entries = result.feed.getEntries();

// テーブルチャートの設定
  var data = new google.visualization.DataTable();
  data.addColumn('string', '日付');
  data.addColumn('number', '訪問数');
  data.addColumn('number', 'ユーザー数');
  data.addColumn('number', 'ページビュー数');
  data.addColumn('number', '平均ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    data.addRow([
       entry.getValueOf('ga:week'),
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews'),
       entry.getValueOf('ga:pageviewsPerVisit')
    ]);
  }
  
  var formatter = new google.visualization.TableNumberFormat({
    fractionDigits: '2'
  });
  formatter.format(data,4);
  var formatter_date = new google.visualization.TablePatternFormat(
    '{0}週'
  );
  formatter_date.format(data,[0]);
  
  var options = {
//    width: 740
  };
  var panel = $('#table_panel_w').get(0);
  var chart_table = new google.visualization.Table(panel);
  chart_table.draw(data, options);

// ラインチャートの設定
  var linechart = new google.visualization.DataTable();
  linechart.addColumn('string', '日付');
  linechart.addColumn('number', '訪問数');
  linechart.addColumn('number', 'ユーザー数');
  linechart.addColumn('number', 'ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    linechart.addRow([
       entry.getValueOf('ga:week'),
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews')
    ]);
  }
  
  var options_line = {
//    width: 740,
    height: 210
  };
  var panel_linechart = $('#linechart_panel_w').get(0);
  var chart_line = new google.visualization.LineChart(panel_linechart);
  chart_line.draw(linechart, options_line);
  
// テーブルの並び替え時にチャートも並び替える
  google.visualization.events.addListener(chart_table, 'sort',
    function(event) {
      linechart.sort([{column: event.column, desc: !event.ascending}]);
      chart_line.draw(linechart, options_line);
    });
}

/*
* プロファイルごとのデータを表示する レポート(1日単位)
*/
function getDataFeed_d() {
  var myFeedUri = 'https://www.google.com/analytics/feeds/data' +
    '?start-date=' + $('#startDate').val() +
    '&end-date=' + $('#endDate').val() +
    '&dimensions=ga:date' +
    '&metrics=ga:visits,ga:visitors,ga:pageviews,ga:pageviewsPerVisit' +
    '&sort=ga:date' +
    '&ids=' + $('#tableId').val();
  
  myService.getDataFeed(myFeedUri, handleDataFeed_d, handleError);
}

function handleDataFeed_d(result) {
  var entries = result.feed.getEntries();

// テーブルチャートの設定
  var data = new google.visualization.DataTable();
  data.addColumn('string', '日付');
  data.addColumn('number', '訪問数');
  data.addColumn('number', 'ユーザー数');
  data.addColumn('number', 'ページビュー数');
  data.addColumn('number', '平均ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    data.addRow([
       entry.getValueOf('ga:date'),
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews'),
       entry.getValueOf('ga:pageviewsPerVisit')
    ]);
  }
  
  var formatter = new google.visualization.TableNumberFormat({
    fractionDigits: '2'
  });
  formatter.format(data,4);
  
  var options = {
//    width: 740
  };
  var panel = $('#table_panel_d').get(0);
  var chart_table = new google.visualization.Table(panel);
  chart_table.draw(data, options);

// ラインチャートの設定
  var linechart = new google.visualization.DataTable();
  linechart.addColumn('string', '日付');
  linechart.addColumn('number', '訪問数');
  linechart.addColumn('number', 'ユーザー数');
  linechart.addColumn('number', 'ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    linechart.addRow([
       entry.getValueOf('ga:date'),
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews')
    ]);
  }
  if (entries.length < 70){
    var panel_width = 700
  }else{
    var panel_width = entries.length*10
  }
  var options_line = {
    width: panel_width,
    height: 210
  };
  var panel_linechart = $('#linechart_panel_d').get(0);
  var chart_line = new google.visualization.LineChart(panel_linechart);
  chart_line.draw(linechart, options_line);
  
// テーブルの並び替え時にチャートも並び替える
  google.visualization.events.addListener(chart_table, 'sort',
    function(event) {
      linechart.sort([{column: event.column, desc: !event.ascending}]);
      chart_line.draw(linechart, options_line);
    });
}

/*
* プロファイルごとのデータを表示する レポート(曜日単位)
*/
function getDataFeed_dow() {
  var myFeedUri = 'https://www.google.com/analytics/feeds/data' +
    '?start-date=' + $('#startDate').val() +
    '&end-date=' + $('#endDate').val() +
    '&dimensions=ga:dayOfWeek' +
    '&metrics=ga:visits,ga:visitors,ga:pageviews,ga:pageviewsPerVisit' +
    '&sort=ga:dayOfWeek' +
    '&ids=' + $('#tableId').val();
  
  myService.getDataFeed(myFeedUri, handleDataFeed_dow, handleError);
}

function handleDataFeed_dow(result) {
  var entries = result.feed.getEntries();
  
  var dayNames = ["日","月","火","水","木","金","土"];

// テーブルチャートの項目設定
  var data = new google.visualization.DataTable();
  data.addColumn('string', '曜日');
  data.addColumn('number', '訪問数');
  data.addColumn('number', 'ユーザー数');
  data.addColumn('number', 'ページビュー数');
  data.addColumn('number', '平均ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    data.addRow([
       dayNames[i],
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews'),
       entry.getValueOf('ga:pageviewsPerVisit')
    ]);
  }
  
  var formatter = new google.visualization.TableNumberFormat({
    fractionDigits: '2'
  });
  formatter.format(data,4);
  
  var options = {
//    width: 740
  };
  var panel = $('#table_panel_dow').get(0);
  var chart_table = new google.visualization.Table(panel);
  chart_table.draw(data, options);
  
// ラインチャートの項目設定
  var linechart = new google.visualization.DataTable();
  linechart.addColumn('string', '曜日');
  linechart.addColumn('number', '訪問数');
  linechart.addColumn('number', 'ユーザー数');
  linechart.addColumn('number', 'ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    linechart.addRow([
       dayNames[i],
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews')
    ]);
  }
  
  var options_line = {
//    width: 740,
    height: 210
  };
  var panel_linechart = $('#linechart_panel_dow').get(0);
  var chart_line = new google.visualization.LineChart(panel_linechart);
  chart_line.draw(linechart, options_line);
  
// テーブルの並び替え時にチャートも並び替える
  google.visualization.events.addListener(chart_table, 'sort',
    function(event) {
      linechart.sort([{column: event.column, desc: !event.ascending}]);
      chart_line.draw(linechart, options_line);
    });
}

/*
* プロファイルごとのデータを表示する レポート_キーワード
*/
function getDataFeed_2() {
  var myFeedUri = 'https://www.google.com/analytics/feeds/data' +
    '?start-date=' + $('#startDate').val() +
    '&end-date=' + $('#endDate').val() +
    '&dimensions=ga:keyword' +
    '&metrics=ga:visits,ga:visitors,ga:pageviews,ga:pageviewsPerVisit' +
    '&sort=-ga:visits' +
    '&max-results=' + $('#maxResults').val() +
    '&ids=' + $('#tableId').val();
  
  myService.getDataFeed(myFeedUri, handleDataFeed_2, handleError);
}

function handleDataFeed_2(result) {
  var entries = result.feed.getEntries();

  $('#view_panel_2').html('<h2>人気キーワードTOP' + $('#maxResults').val() + '</h2>');

// テーブルチャートの設定
  var data = new google.visualization.DataTable();
  data.addColumn('number', 'No');
  data.addColumn('string', 'キーワード');
  data.addColumn('number', '訪問数');
  data.addColumn('number', 'ユーザー数');
  data.addColumn('number', 'ページビュー数');
  data.addColumn('number', '平均ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    data.addRow([
       i+1,
       entry.getValueOf('ga:keyword'),
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews'),
       entry.getValueOf('ga:pageviewsPerVisit')
    ]);
  }
  
  var formatter = new google.visualization.TableNumberFormat({
    fractionDigits: '2'
  });
  formatter.format(data,5);
  
  var options = {
//    width: 740
  };
  var panel = $('#table_panel_2').get(0);
  var chart_table = new google.visualization.Table(panel);
  chart_table.draw(data, options);

// 円チャートの設定
  var piechart = new google.visualization.DataTable();
  piechart.addColumn('string', 'キーワード');
  piechart.addColumn('number', '訪問数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    piechart.addRow([
       entry.getValueOf('ga:keyword'),
       entry.getValueOf('ga:visits')
    ]);
  }
  var options_pie = {
//    width: 740,
    height: 400,
    is3D: true
  };
  
  var panel_piechart = $('#piechart_panel_2').get(0);
  var chart_pie = new google.visualization.PieChart(panel_piechart);
  chart_pie.draw(piechart, options_pie);
}

/*
* プロファイルごとのデータを表示する レポート_リンク元サイト
*/
function getDataFeed_3() {
  var myFeedUri = 'https://www.google.com/analytics/feeds/data' +
    '?start-date=' + $('#startDate').val() +
    '&end-date=' + $('#endDate').val() +
    '&dimensions=ga:source' +
    '&metrics=ga:visits,ga:visitors,ga:pageviews,ga:pageviewsPerVisit' +
    '&sort=-ga:visits' +
    '&max-results=' + $('#maxResults').val() +
    '&ids=' + $('#tableId').val();
  
  myService.getDataFeed(myFeedUri, handleDataFeed_3, handleError);
}

function handleDataFeed_3(result) {
  var entries = result.feed.getEntries();

  $('#view_panel_3').html('<h2>人気リンク元サイトTOP' + $('#maxResults').val() + '</h2>');

// テーブルチャートの設定
  var data = new google.visualization.DataTable();
  data.addColumn('number', 'No');
  data.addColumn('string', 'リンク元サイト');
  data.addColumn('number', '訪問数');
  data.addColumn('number', 'ユーザー数');
  data.addColumn('number', 'ページビュー数');
  data.addColumn('number', '平均ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    data.addRow([
       i+1,
       entry.getValueOf('ga:source'),
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews'),
       entry.getValueOf('ga:pageviewsPerVisit')
     ]);
  }
  
  var formatter = new google.visualization.TableNumberFormat({
    fractionDigits: '2'
  });
  formatter.format(data,5);
  
  var options = {
//    width: 740
  };
  var panel = $('#table_panel_3').get(0);
  var chart_table = new google.visualization.Table(panel);
  chart_table.draw(data, options);

// 円チャートの設定
  var piechart = new google.visualization.DataTable();
  piechart.addColumn('string', 'リンク元サイト');
  piechart.addColumn('number', '訪問数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    piechart.addRow([
       entry.getValueOf('ga:source'),
       entry.getValueOf('ga:visits')
    ]);
  }
  var options_pie = {
//    width: 740,
    height: 400,
    is3D: true
  };

  var panel_piechart = $('#piechart_panel_3').get(0);
  var chart_pie = new google.visualization.PieChart(panel_piechart);
  chart_pie.draw(piechart, options_pie);
}

/*
* プロファイルごとのデータを表示する レポート_コンテンツ別
*/
function getDataFeed_4() {
  var myFeedUri = 'https://www.google.com/analytics/feeds/data' +
    '?start-date=' + $('#startDate').val() +
    '&end-date=' + $('#endDate').val() +
    '&dimensions=ga:pagePath' +
    '&metrics=ga:visits,ga:visitors,ga:pageviews' +
    '&sort=-ga:visits' +
    '&max-results=' + $('#maxResults').val() +
    '&ids=' + $('#tableId').val();
  
  myService.getDataFeed(myFeedUri, handleDataFeed_4, handleError);
}

function handleDataFeed_4(result) {
  var entries = result.feed.getEntries();

  $('#view_panel_4').html('<h2>人気コンテンツ(ページ)TOP' + $('#maxResults').val() + '</h2>');

// テーブルチャートの設定
  var data = new google.visualization.DataTable();
  data.addColumn('number', 'No');
  data.addColumn('string', 'ページURL');
  data.addColumn('number', '訪問数');
  data.addColumn('number', 'ユーザー数');
  data.addColumn('number', 'ページビュー数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    data.addRow([
       i+1,
       entry.getValueOf('ga:pagePath'),
       entry.getValueOf('ga:visits'),
       entry.getValueOf('ga:visitors'),
       entry.getValueOf('ga:pageviews')
    ]);
  }
  
  var options = {
//    width: 740
  };
  var panel = $('#table_panel_4').get(0);
  var chart_table = new google.visualization.Table(panel);
  chart_table.draw(data, options);

// 円チャートの設定
  var piechart = new google.visualization.DataTable();
  piechart.addColumn('string', 'ページ');
  piechart.addColumn('number', '訪問数');

  for (var i = 0, entry; entry = entries[i]; ++i) {
    piechart.addRow([
       entry.getValueOf('ga:pagePath'),
       entry.getValueOf('ga:visits')
    ]);
  }
  var options_pie = {
//    width: 740,
    height: 400,
    is3D: true,
  };
  var panel_piechart = $('#piechart_panel_4').get(0);
  var chart_pie = new google.visualization.PieChart(panel_piechart);
  chart_pie.draw(piechart, options_pie);
}

function handleError(e) {
  var error = '「Table ID」か「日付」の設定が正しくないか 入力されていないようです\n';
  if (e.cause) {
    error += e.cause.status;
  } else {
    error.message;
  }
  alert(error);
}

});